- hosts: localhost
  gather_facts: no
  connection: local
  tasks:
    - name: Import Variables via Tasks
      include_tasks:
        file: import_vars.yml

    - name: Install host python requirements
      pip:
        requirements: "{{ playbook_dir }}/requirements.txt"
        extra_args: --upgrade

    - name: Create directory on host for where container files will be persisted.
      file:
        path: "{{ host_save_dir }}/consensus-node-{{ item }}/ansible/passwd.d"
        owner: "{{ lookup('env', 'USER') }}"
        state: directory
      become: yes
      loop: "{{ consensus_node_ids }}"

    - name: Login to Docker Registry
      docker_login:
        registry: "{{ docker_registry_base }}"
        username: "{{ docker_registry_username }}"
        password: "{{ docker_registry_password }}"

    - name: Create toolchain container
      docker_container:
        name: "validator-toolchain-{{ item }}"
        image: "{{ docker_registry_base }}/xand-devops-toolchain:{{ toolchain_version }}"
        command: tail -f /dev/null
        volumes:
          - "{{ host_save_dir }}/consensus-node-{{ item }}:{{ remote_save_dir }}"
      loop: "{{ consensus_node_ids }}"

    - name: Add container to inventory
      add_host:
        name: "validator-toolchain-{{ item }}"
        ansible_host: "validator-toolchain-{{ item }}"
        ansible_connection: docker
        ansible_python_interpreter: /usr/bin/python3
        ansible_pipelining: yes
        host_xand_dir: "{{ host_save_dir }}/consensus-node-{{ item }}"
        groups:
          - consensus_node
      loop: "{{ consensus_node_ids }}"

- hosts: consensus_node
  gather_facts: no
  roles:
    - consensus-node

- hosts: localhost
  gather_facts: no
  connection: local
  tasks:
    - name: Destroy toolchain container
      docker_container:
        name: "validator-toolchain-{{ item }}"
        state: stopped
        force_kill: yes
      loop: "{{ consensus_node_ids }}"
